Index: /trunk/src/sh_hash.c
===================================================================
--- /trunk/src/sh_hash.c	(revision 584)
+++ /trunk/src/sh_hash.c	(revision 1)
@@ -2171,6 +2585,6 @@
     } 
   
-  if ( (theFile->check_flags & MODI_ATM) != 0 &&
-       theFile->atime != (time_t) p->theFile.atime)
+  if ( theFile->atime != (time_t) p->theFile.atime &&
+       (theFile->check_mask & MODI_ATM) != 0)
     {
       modi_mask |= MODI_ATM;
@@ -2184,5 +2598,5 @@
    */
   if ( theFile->ctime != (time_t) p->theFile.ctime &&
-       (theFile->check_flags & MODI_CTM) != 0)
+       (theFile->check_mask & MODI_CTM) != 0)
     {
       modi_mask |= MODI_CTM;
@@ -2192,24 +2606,20 @@
 
   if ( theFile->size != (off_t) p->theFile.size &&
-       (theFile->check_flags & MODI_SIZ) != 0)
-    {
-      if ((theFile->check_flags & MODI_SGROW) == 0 || 
-	  theFile->size < (off_t) p->theFile.size)
+       (theFile->check_mask & MODI_SIZ) != 0)
+    {
+      if (class == SH_LEVEL_LOGGROW && theFile->size < (off_t) p->theFile.size)
 	{
 	  modi_mask |= MODI_SIZ;
 	  change_code[9] = 'S';
 	  TPT ((0, FIL__, __LINE__, _("mod=<size>")));
-	}
+	} 
+      else if (class != SH_LEVEL_LOGGROW)
+	{ 
+	  modi_mask |= MODI_SIZ;
+	  change_code[9] = 'S';
+	  TPT ((0, FIL__, __LINE__, _("mod=<size>")));
+	} 
     }
   change_code[10] = '\0';
-
-  /* --- Directories special case ---
-   */
-  if (p->theFile.c_mode[0] == 'd'                               &&
-      0 == (modi_mask & ~(MODI_SIZ|MODI_ATM|MODI_CTM|MODI_MTM)) && 
-      sh_loosedircheck == S_TRUE)
-    {
-      modi_mask = 0;
-    }
 
   /* --- Report full details. ---
@@ -2217,5 +2627,5 @@
   if (modi_mask != 0 && sh.flag.fulldetail == S_TRUE)
     {
-      if ((theFile->check_flags & MODI_ATM) == 0)
+      if ((theFile->check_mask & MODI_ATM) == 0)
 	modi_mask = MASK_READONLY_;
       else
@@ -2225,74 +2635,47 @@
   /* --- Report on modified files. ---
    */
-  if (modi_mask != 0 && (!SH_FFLAG_REPORTED_SET(p->fflags)))
+  if (modi_mask != 0 && p->reported == S_FALSE)
     { 
-      tmp = SH_ALLOC(SH_MSG_BUF);
-      msg = SH_ALLOC(SH_MSG_BUF);
+      tmp = SH_ALLOC(SH_BUFSIZE);
+      msg = SH_ALLOC(SH_BUFSIZE);
       msg[0] = '\0';
 
-      sh_files_fixup_mask(class, &(cf_report.newflags));
-
-      if ( (report_checkflags != S_FALSE) && (cf_report.oldflags != cf_report.newflags))
-	{
-	  sl_snprintf(tmp, SH_MSG_BUF,
-#ifdef SH_USE_XML
-		      _("checkflags_old=\"0%lo\" checkflags_new=\"0%lo\" "),
-#else
-		      _("checkflags_old=<0%lo>, checkflags_new=<0%lo>, "),
-#endif
-		      cf_report.oldflags,  cf_report.newflags);
-	  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-	}
-
       if (   ((modi_mask & MODI_MOD) != 0)
-#if defined(HAVE_LIBPRELUDE)
-	     || ((modi_mask & MODI_USR) != 0)
-	     || ((modi_mask & MODI_GRP) != 0)
+#if defined(HAVE_LIBPRELUDE) && defined(HAVE_LIBPRELUDE_9)
+	  || ((modi_mask & MODI_USR) != 0)
+	  || ((modi_mask & MODI_GRP) != 0)
 #endif
 	     )
 	{
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
-	  sl_snprintf(tmp, SH_MSG_BUF, 
+#if defined(__linux__)
+	  sl_snprintf(tmp, SH_BUFSIZE, 
 #ifdef SH_USE_XML
 		      _("mode_old=\"%s\" mode_new=\"%s\" attr_old=\"%s\" attr_new=\"%s\" imode_old=\"%ld\" imode_new=\"%ld\" iattr_old=\"%ld\" iattr_new=\"%ld\" "),
 #else
-		      _("mode_old=<%s>, mode_new=<%s>, attr_old=<%s>, attr_new=<%s>, imode_old=<%ld>, imode_new=<%ld>, iattr_old=<%ld>, iattr_new=<%ld>, "),
+		      _("mode_old=<%s>, mode_new=<%s>, attr_old=<%s>, attr_new=<%s>, "),
 #endif
 		      p->theFile.c_mode, theFile->c_mode,
-		      p->theFile.c_attributes, theFile->c_attributes,
-
-		      (long) p->theFile.mode, (long) theFile->mode,
+		      p->theFile.c_attributes, theFile->c_attributes
+#ifdef SH_USE_XML
+		      , (long) p->theFile.mode, (long) theFile->mode,
 		      (long) p->theFile.attributes, 
 		      (long) theFile->attributes
+#endif
 		      );
 #else
 #ifdef SH_USE_XML
-	  sl_snprintf(tmp, SH_MSG_BUF, 
+	  sl_snprintf(tmp, SH_BUFSIZE, 
 		      _("mode_old=\"%s\" mode_new=\"%s\" imode_old=\"%ld\" imode_new=\"%ld\" "),
-		      p->theFile.c_mode, theFile->c_mode,
-		      (long) p->theFile.mode, (long) theFile->mode);
-#else
-	  sl_snprintf(tmp, SH_MSG_BUF, _("mode_old=<%s>, mode_new=<%s>, "),
-		      p->theFile.c_mode, theFile->c_mode);
-#endif
-#endif
-	  sl_strlcat(msg, tmp, SH_MSG_BUF);
-
-#if defined(USE_ACL) || defined(USE_XATTR)
-	  if (theFile->attr_string != NULL || p->attr_string != NULL)
-	    {
-	      sl_snprintf(tmp, SH_MSG_BUF, 
+#else
+		      sl_snprintf(tmp, SH_BUFSIZE, _("mode_old=<%s>, mode_new=<%s>, "),
+#endif
+		      p->theFile.c_mode, theFile->c_mode
 #ifdef SH_USE_XML
-			  _("acl_old=\"%s\" acl_new=\"%s\" "),
-#else
-			  _("acl_old=<%s>, acl_new=<%s>, "),
-#endif
-			  (p->attr_string)       ? p->attr_string       : _("none"), 
-			  (theFile->attr_string) ? theFile->attr_string : _("none"));
-	      
-	      sl_strlcat(msg, tmp, SH_MSG_BUF);
-	    }
-#endif
-
+		      , (long) p->theFile.mode, (long) theFile->mode
+#endif
+		      );
+#endif
+	  sl_strlcat(msg, tmp, SH_BUFSIZE);
+#ifdef REPLACE_OLD
 	  if ((modi_mask & MODI_MOD) != 0)
 	    {
@@ -2305,50 +2688,37 @@
 		  sl_strlcpy(p->theFile.c_mode, theFile->c_mode, 11);
 		  p->theFile.mode = theFile->mode;
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
+#if defined(__linux__)
 		  sl_strlcpy(p->theFile.c_attributes,theFile->c_attributes,16);
 		  p->theFile.attributes = theFile->attributes;
 #endif
-#if defined(USE_ACL) || defined(USE_XATTR)
-		  if      (p->attr_string == NULL && theFile->attr_string != NULL)
-		    { p->attr_string = sh_util_strdup (theFile->attr_string); }
-		  else if (p->attr_string != NULL && theFile->attr_string == NULL)
-		    { SH_FREE(p->attr_string); p->attr_string = NULL; }
-		  else if (theFile->attr_string != NULL && p->attr_string != NULL)
-		    { 
-		      if (0 != strcmp(theFile->attr_string, p->attr_string))
-			{
-			  SH_FREE(p->attr_string);
-			  p->attr_string = sh_util_strdup (theFile->attr_string);
-			}
-		    }
-#endif
 		}
 	    }
-
+#endif
 	}
 
       if ((modi_mask & MODI_HLN) != 0)
 	{
-	  sl_snprintf(tmp, SH_MSG_BUF, 
+	  sl_snprintf(tmp, SH_BUFSIZE, 
 #ifdef SH_USE_XML
-		      _("hardlinks_old=\"%lu\" hardlinks_new=\"%lu\" "),
-#else
-		      _("hardlinks_old=<%lu>, hardlinks_new=<%lu>, "),
+		      _("hardlinks_old=\"%ld\" hardlinks_new=\"%ld\" "),
+#else
+		      _("hardlinks_old=<%ld>, hardlinks_new=<%ld>, "),
 #endif
 		      (unsigned long) p->theFile.hardlinks, 
 		      (unsigned long) theFile->hardlinks);
-	  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
+	  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+#ifdef REPLACE_OLD
 	  if (sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE)
 	    p->theFile.hardlinks = theFile->hardlinks;
+#endif
 	}
 
       if ((modi_mask & MODI_RDEV) != 0)
 	{
-	  sl_snprintf(tmp, SH_MSG_BUF,
+	  sl_snprintf(tmp, SH_BUFSIZE,
 #ifdef SH_USE_XML 
-		      _("device_old=\"%lu,%lu\" device_new=\"%lu,%lu\" idevice_old=\"%lu\" idevice_new=\"%lu\" "),
-#else
-		      _("device_old=<%lu,%lu>, device_new=<%lu,%lu>, "),
+		      _("device_old=\"%ld,%ld\" device_new=\"%ld,%ld\" idevice_old=\"%ld\" idevice_new=\"%ld\" "),
+#else
+		      _("device_old=<%ld,%ld>, device_new=<%ld,%ld>, "),
 #endif
 		      (unsigned long) major(p->theFile.rdev), 
@@ -2361,72 +2731,46 @@
 #endif
 		      );
-	  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
+	  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+#ifdef REPLACE_OLD
 	  if (sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE)
 	    p->theFile.rdev = theFile->rdev;
+#endif
 	}
 
       if ((modi_mask & MODI_INO) != 0)
 	{
-	  sl_snprintf(tmp, SH_MSG_BUF,
+	  sl_snprintf(tmp, SH_BUFSIZE,
 #ifdef SH_USE_XML 
-		      _("inode_old=\"%lu\" inode_new=\"%lu\" "),
-#else
-		      _("inode_old=<%lu>, inode_new=<%lu>, "),
+		      _("inode_old=\"%ld\" inode_new=\"%ld\" "),
+#else
+		      _("inode_old=<%ld>, inode_new=<%ld>, "),
 #endif
 		      (unsigned long) p->theFile.ino, 
 		      (unsigned long) theFile->ino);
-	  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
+	  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+#ifdef REPLACE_OLD
 	  if (sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE)
-	    {
-	      p->theFile.ino = theFile->ino;
-	      p->theFile.dev = theFile->dev;
-	    }
-	}
-
-
-      /* 
-       * also report device for prelude
-       */
-#if defined(HAVE_LIBPRELUDE)
-      if ((modi_mask & MODI_INO) != 0)
-	{
-	  sl_snprintf(tmp, SH_MSG_BUF,
-#ifdef SH_USE_XML 
-		      _("dev_old=\"%lu,%lu\" dev_new=\"%lu,%lu\" "),
-#else
-		      _("dev_old=<%lu,%lu>, dev_new=<%lu,%lu>, "),
-#endif
-		      (unsigned long) major(p->theFile.dev),
-		      (unsigned long) minor(p->theFile.dev),
-		      (unsigned long) major(theFile->dev),
-		      (unsigned long) minor(theFile->dev)
+	    p->theFile.ino = theFile->ino;
+#endif
+	}
+
+      if (   ((modi_mask & MODI_USR) != 0)
+#if defined(HAVE_LIBPRELUDE) && defined(HAVE_LIBPRELUDE_9)
+	  || ((modi_mask & MODI_MOD) != 0)
+#endif
+	  )
+	{
+#ifdef SH_USE_XML
+	  sl_snprintf(tmp, SH_BUFSIZE, _("owner_old=\"%s\" owner_new=\"%s\" iowner_old=\"%ld\" iowner_new=\"%ld\" "),
+#else
+	  sl_snprintf(tmp, SH_BUFSIZE, _("owner_old=<%s>, owner_new=<%s>, "),
+#endif
+		      p->theFile.c_owner, theFile->c_owner
+#ifdef SH_USE_XML
+		      , (long) p->theFile.owner, (long) theFile->owner
+#endif
 		      );
-	  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
-	  if (sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE)
-	    p->theFile.dev = theFile->dev;
-	}
-#endif
-
-      if (   ((modi_mask & MODI_USR) != 0)
-#if defined(HAVE_LIBPRELUDE)
-	  || ((modi_mask & MODI_MOD) != 0)
-#endif
-	  )
-	{
-#ifdef SH_USE_XML
-	  sl_snprintf(tmp, SH_MSG_BUF, 
-		      _("owner_old=\"%s\" owner_new=\"%s\" iowner_old=\"%ld\" iowner_new=\"%ld\" "),
-#else
-	  sl_snprintf(tmp, SH_MSG_BUF, 
-		      _("owner_old=<%s>, owner_new=<%s>, iowner_old=<%ld>, iowner_new=<%ld>, "),
-#endif
-		      p->theFile.c_owner, theFile->c_owner, 
-		      (long) p->theFile.owner, (long) theFile->owner
-		      );
-	  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
+	  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+#ifdef REPLACE_OLD
 	  if ((modi_mask & MODI_USR) != 0) {
 	    if (sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE)
@@ -2436,8 +2780,9 @@
 	      }
 	  }
+#endif
 	}
 
       if (   ((modi_mask & MODI_GRP) != 0)
-#if defined(HAVE_LIBPRELUDE)
+#if defined(HAVE_LIBPRELUDE) && defined(HAVE_LIBPRELUDE_9)
 	  || ((modi_mask & MODI_MOD) != 0)
 #endif
@@ -2445,17 +2790,14 @@
 	{
 #ifdef SH_USE_XML
-	  sl_snprintf(tmp, SH_MSG_BUF, 
-		      _("group_old=\"%s\" group_new=\"%s\" igroup_old=\"%ld\" igroup_new=\"%ld\" "),
+	  sl_snprintf(tmp, SH_BUFSIZE, _("group_old=\"%s\" group_new=\"%s\" igroup_old=\"%ld\" igroup_new=\"%ld\" "),
 		      p->theFile.c_group, theFile->c_group,
 		      (long) p->theFile.group, (long) theFile->group);
 #else
-	  sl_snprintf(tmp, SH_MSG_BUF, 
-		      _("group_old=<%s>, group_new=<%s>, igroup_old=<%ld>, igroup_new=<%ld>, "),
-		      p->theFile.c_group, theFile->c_group,
-		      (long) p->theFile.group, (long) theFile->group);
-#endif
-
-	  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
+	  sl_snprintf(tmp, SH_BUFSIZE, _("group_old=<%s>, group_new=<%s>, "),
+		      p->theFile.c_group, theFile->c_group);
+#endif
+
+	  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+#ifdef REPLACE_OLD
           if ((modi_mask & MODI_GRP) != 0) {
 	    if (sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE)
@@ -2465,66 +2807,71 @@
 	      }
 	  }
+#endif
 	}
 
       if ((modi_mask & MODI_SIZ) != 0)
 	{
-	  sl_snprintf(tmp, SH_MSG_BUF, sh_hash_size_format(),
+	  sl_snprintf(tmp, SH_BUFSIZE, sh_hash_size_format(),
 		      (UINT64) p->theFile.size, 
 		      (UINT64) theFile->size);
-	  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
+	  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+#ifdef REPLACE_OLD
 	  if (sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE)
 	    p->theFile.size = theFile->size;
+#endif
 	}
 
       if ((modi_mask & MODI_CTM) != 0)
 	{
-	  (void) sh_unix_gmttime (p->theFile.ctime, timstr1c, sizeof(timstr1c));
-	  (void) sh_unix_gmttime (theFile->ctime,   timstr2c, sizeof(timstr2c));
+	  sl_strlcpy (timstr1c, sh_unix_gmttime (p->theFile.ctime), 32);
+	  sl_strlcpy (timstr2c, sh_unix_gmttime (theFile->ctime),   32);
 #ifdef SH_USE_XML
-	  sl_snprintf(tmp, SH_MSG_BUF, _("ctime_old=\"%s\" ctime_new=\"%s\" "),
+	  sl_snprintf(tmp, SH_BUFSIZE, _("ctime_old=\"%s\" ctime_new=\"%s\" "),
 		      timstr1c, timstr2c);
 #else
-	  sl_snprintf(tmp, SH_MSG_BUF, _("ctime_old=<%s>, ctime_new=<%s>, "),
+	  sl_snprintf(tmp, SH_BUFSIZE, _("ctime_old=<%s>, ctime_new=<%s>, "),
 		      timstr1c, timstr2c);
 #endif
-	  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
+	  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+#ifdef REPLACE_OLD
 	  if (sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE)
 	    p->theFile.ctime = theFile->ctime;
+#endif
 	}
 
       if ((modi_mask & MODI_ATM) != 0)
 	{
-	  (void) sh_unix_gmttime (p->theFile.atime, timstr1a, sizeof(timstr1a));
-	  (void) sh_unix_gmttime (theFile->atime,   timstr2a, sizeof(timstr2a));
+	  sl_strlcpy (timstr1a, sh_unix_gmttime (p->theFile.atime), 32);
+	  sl_strlcpy (timstr2a, sh_unix_gmttime (theFile->atime),   32);
 #ifdef SH_USE_XML
-	  sl_snprintf(tmp, SH_MSG_BUF, _("atime_old=\"%s\" atime_new=\"%s\" "),
+	  sl_snprintf(tmp, SH_BUFSIZE, _("atime_old=\"%s\" atime_new=\"%s\" "),
 		      timstr1a, timstr2a);
 #else
-	  sl_snprintf(tmp, SH_MSG_BUF, _("atime_old=<%s>, atime_new=<%s>, "),
+	  sl_snprintf(tmp, SH_BUFSIZE, _("atime_old=<%s>, atime_new=<%s>, "),
 		      timstr1a, timstr2a);
 #endif
-	  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
+	  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+#ifdef REPLACE_OLD
 	  if (sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE)
 	    p->theFile.atime = theFile->atime;
+#endif
 	}
 
       if ((modi_mask & MODI_MTM) != 0)
 	{
-	  (void) sh_unix_gmttime (p->theFile.mtime, timstr1m, sizeof(timstr1m));
-	  (void) sh_unix_gmttime (theFile->mtime,   timstr2m, sizeof(timstr2m));
+	  sl_strlcpy (timstr1m, sh_unix_gmttime (p->theFile.mtime), 32);
+	  sl_strlcpy (timstr2m, sh_unix_gmttime (theFile->mtime),   32);
 #ifdef SH_USE_XML
-	  sl_snprintf(tmp, SH_MSG_BUF, _("mtime_old=\"%s\" mtime_new=\"%s\" "),
+	  sl_snprintf(tmp, SH_BUFSIZE, _("mtime_old=\"%s\" mtime_new=\"%s\" "),
 		      timstr1m, timstr2m);
 #else
-	  sl_snprintf(tmp, SH_MSG_BUF, _("mtime_old=<%s>, mtime_new=<%s>, "),
+	  sl_snprintf(tmp, SH_BUFSIZE, _("mtime_old=<%s>, mtime_new=<%s>, "),
 		      timstr1m, timstr2m);
 #endif
-	  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
+	  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+#ifdef REPLACE_OLD
 	  if (sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE)
 	    p->theFile.mtime = theFile->mtime;
+#endif
 	}
 
@@ -2532,5 +2879,5 @@
       if ((modi_mask & MODI_CHK) != 0)
 	{
-	  sl_snprintf(tmp, SH_MSG_BUF, 
+	  sl_snprintf(tmp, SH_BUFSIZE, 
 #ifdef SH_USE_XML
 		      _("chksum_old=\"%s\" chksum_new=\"%s\" "),
@@ -2539,96 +2886,52 @@
 #endif
 		      p->theFile.checksum, fileHash);
-	  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
+	  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+#ifdef REPLACE_OLD
 	  if (sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE)
-	    {
-	      sl_strlcpy(p->theFile.checksum, fileHash, KEY_LEN+1);
-	      if ((theFile->check_flags & MODI_SGROW) != 0)	      
-		p->theFile.size  = theFile->size;
-	    }
-
-
-	  if (theFile->c_mode[0] != 'l' && theFile->link_path &&
-	      strlen(theFile->link_path) > 2)
-	    modi_mask |= MODI_LNK;
-	}
-
-
-      if ((modi_mask & MODI_LNK) != 0 /* && theFile->c_mode[0] == 'l' */)
-	{
-	  if (theFile->link_path)
-	    tmp_lnk     = sh_util_safe_name(theFile->link_path);
-	  else
-	    tmp_lnk     = sh_util_strdup("-");
-	  if (p->linkpath)
-	    tmp_lnk_old = sh_util_safe_name(p->linkpath);
-	  else
-	    tmp_lnk_old = sh_util_strdup("-");
+	    sl_strlcpy(p->theFile.checksum, fileHash, KEY_LEN+1);
+#endif
+	}
+
+
+      if ((modi_mask & MODI_LNK) != 0 && theFile->c_mode[0] == 'l')
+	{
+	  tmp_lnk     = sh_util_safe_name(theFile->linkpath);
+	  tmp_lnk_old = sh_util_safe_name(p->linkpath);
 #ifdef SH_USE_XML
-	  sl_snprintf(tmp, SH_MSG_BUF, _("link_old=\"%s\" link_new=\"%s\" "),
+	  sl_snprintf(tmp, SH_BUFSIZE, _("link_old=\"%s\" link_new=\"%s\" "),
 		      tmp_lnk_old, tmp_lnk);
 #else
-	  sl_snprintf(tmp, SH_MSG_BUF, _("link_old=<%s>, link_new=<%s>, "),
+	  sl_snprintf(tmp, SH_BUFSIZE, _("link_old=<%s>, link_new=<%s>"),
 		      tmp_lnk_old, tmp_lnk);
 #endif
 	  SH_FREE(tmp_lnk);
 	  SH_FREE(tmp_lnk_old);
-	  sl_strlcat(msg, tmp, SH_MSG_BUF); 
-
+	  sl_strlcat(msg, tmp, SH_BUFSIZE); 
+#ifdef REPLACE_OLD
 	  if (sh.flag.reportonce == S_TRUE && sh.flag.update == S_FALSE)
 	    {
 	      if (p->linkpath != NULL)
 		SH_FREE(p->linkpath);
-	      if (!(theFile->link_path))
-		p->linkpath = sh_util_strdup("-");
-	      else
-		p->linkpath = sh_util_strdup(theFile->link_path);
+	      p->linkpath = (char*)SH_ALLOC (sl_strlen(theFile->linkpath) + 1);
+	      sl_strlcpy(p->linkpath, theFile->linkpath, 
+			 sl_strlen(theFile->linkpath) + 1);
 	    }
-	}
-
-      if (MODI_AUDIT_ENABLED(theFile->check_flags))
-	{
-	  char result[256];
-	  
-	  sh_error_handle (SH_ERR_INFO, FIL__, __LINE__, 
-			   0, MSG_E_SUBGPATH,
-			   _("Fetching audit record"),
-			   _("sh_hash"),  theFile->fullpath );
-
-	  if (NULL != sh_audit_fetch (theFile->fullpath, theFile->mtime, theFile->ctime, theFile->atime,
-				      result, sizeof(result)))
-	    {
-#ifdef SH_USE_XML
-	      sl_strlcat(msg, _("obj=\""), SH_MSG_BUF);
-#else
-	      sl_strlcat(msg, _("obj=<"), SH_MSG_BUF);
-#endif
-
-	      sl_strlcat(msg, result, SH_MSG_BUF);
-
-#ifdef SH_USE_XML
-	      sl_strlcat(msg, _("\" "), SH_MSG_BUF);
-#else
-	      sl_strlcat(msg, _(">"), SH_MSG_BUF);
-#endif
-	    } 
-	}
-
-      /****************************************************
-       *
-       * REPORT on file change
-       *
-       ****************************************************/
+#endif
+	}
+
+
       tmp_path = sh_util_safe_name(theFile->fullpath);
-      if (!sh_global_check_silent)
-	sh_error_handle(log_severity, FIL__, __LINE__, 
-			(long) modi_mask, MSG_FI_CHAN,
-			(policy_override == NULL) ? _(policy[class]):log_policy,
-			change_code, tmp_path, msg);
-      ++sh.statistics.files_report;
+      sh_error_handle(log_severity, FIL__, __LINE__, 
+		      (long) modi_mask, MSG_FI_CHAN,
+		      (policy_override == NULL) ? _(policy[class]):log_policy,
+		      change_code, tmp_path, msg);
 
       SH_FREE(tmp_path);
       SH_FREE(tmp);
       SH_FREE(msg);
+
+#ifndef REPLACE_OLD
+      p->reported = S_TRUE;
+#endif
 
       if (S_TRUE  == sh.flag.update)
@@ -2641,40 +2944,17 @@
 	      sl_strlcpy(theFile->c_mode, p->theFile.c_mode, 11);
 	      theFile->mode  =  p->theFile.mode;
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
+#if defined(__linux__)
 	      sl_strlcpy(theFile->c_attributes, p->theFile.c_attributes, 16);
 	      theFile->attributes =  p->theFile.attributes;
-#endif
-#if defined(USE_ACL) || defined(USE_XATTR)
-	      if      (theFile->attr_string == NULL && p->attr_string != NULL)
-		{ theFile->attr_string = sh_util_strdup (p->attr_string); }
-	      else if (theFile->attr_string != NULL && p->attr_string == NULL)
-		{ SH_FREE(theFile->attr_string); theFile->attr_string = NULL; }
-	      else if (theFile->attr_string != NULL && p->attr_string != NULL)
-		{ 
-		  if (0 != strcmp(theFile->attr_string, p->attr_string))
-		    {
-		      SH_FREE(theFile->attr_string);
-		      theFile->attr_string = sh_util_strdup (p->attr_string);
-		    }
-		}
 #endif
 	      
 	      if (theFile->c_mode[0] == 'l') /* c_mode is already copied */
 		{
-		  if (theFile->link_path)
-		    SH_FREE(theFile->link_path);
-		  if (p->linkpath)
-		    theFile->link_path = sh_util_strdup(p->linkpath);
-		  else
-		    theFile->link_path = sh_util_strdup("-");
+		  sl_strlcpy(theFile->linkpath, p->linkpath, PATH_MAX);
 		}
 	      else
 		{
-		  if (theFile->link_path)
-		    SH_FREE(theFile->link_path);
-		  if (p->linkpath)
-		    theFile->link_path = sh_util_strdup(p->linkpath);
-		  else
-		    theFile->link_path = NULL;
+		  theFile->linkpath[0] = '-';
+		  theFile->linkpath[1] = '\0';
 		}
 	      
@@ -2697,10 +2977,8 @@
 	      theFile->hardlinks = p->theFile.hardlinks;
 	      
-	      SET_SH_FFLAG_VISITED(p->fflags);
-	      CLEAR_SH_FFLAG_CHECKED(p->fflags);
-	      retval = 1;
-	      goto unlock_and_return;
+	      p->visited = S_TRUE;
+	      SL_RETURN(1, _("sh_hash_compdata"));
 	    }
-	  else /* if (sh.flag.reportonce == S_TRUE) */
+	  else if (sh.flag.reportonce == S_TRUE)
 	    {
 	      /* we replace the data in the in-memory copy of the
@@ -2710,34 +2988,27 @@
 	      sl_strlcpy(p->theFile.c_mode, theFile->c_mode, 11);
 	      p->theFile.mode  =  theFile->mode;
-#if defined(__linux__) || defined(HAVE_STAT_FLAGS)
+#if defined(__linux__)
 	      sl_strlcpy(p->theFile.c_attributes, theFile->c_attributes, 16);
 	      p->theFile.attributes = theFile->attributes;
 #endif
-#if defined(USE_ACL) || defined(USE_XATTR)
-	      if      (p->attr_string == NULL && theFile->attr_string != NULL)
-		{ p->attr_string = sh_util_strdup (theFile->attr_string); }
-	      else if (p->attr_string != NULL && theFile->attr_string == NULL)
-		{ SH_FREE(p->attr_string); p->attr_string = NULL; }
-	      else if (theFile->attr_string != NULL && p->attr_string != NULL)
-		{ 
-		  if (0 != strcmp(theFile->attr_string, p->attr_string))
-		    {
-		      SH_FREE(p->attr_string);
-		      p->attr_string = sh_util_strdup (theFile->attr_string);
-		    }
-		}
-#endif
 	      
-	      if (theFile->c_mode[0] == 'l' || theFile->link_path)
+	      if (theFile->c_mode[0] == 'l')
 		{
                   if (p->linkpath != NULL)
 		    SH_FREE(p->linkpath);
-		  p->linkpath = sh_util_strdup(theFile->link_path);
+		  p->linkpath = SH_ALLOC(1 + strlen(theFile->linkpath));
+		  sl_strlcpy(p->linkpath, theFile->linkpath, 
+			     1 + strlen(theFile->linkpath));
 		}
 	      else
 		{
-	          if (p->linkpath != NULL)
-		    SH_FREE(p->linkpath);
-		  p->linkpath = sh_util_strdup("-");
+	          if (p->linkpath != NULL) {
+		    p->linkpath[0] = '-';
+		    p->linkpath[1] = '\0';
+                  } else {
+		    p->linkpath = SH_ALLOC(2);
+		    p->linkpath[0] = '-';
+                    p->linkpath[1] = '\0';
+                  }
 		}
 	      
@@ -2763,11 +3034,7 @@
     }
 
-  SET_SH_FFLAG_VISITED(p->fflags);
-  CLEAR_SH_FFLAG_CHECKED(p->fflags);
-
- unlock_and_return:
-  ; /* 'label at end of compound statement */
-  SH_MUTEX_UNLOCK(mutex_hash);
-  SL_RETURN(retval, _("sh_hash_compdata"));
+  p->visited = S_TRUE;
+
+  SL_RETURN(0, _("sh_hash_compdata"));
 }
 
@@ -2777,266 +3044,91 @@
   int         i;
 
-  SL_ENTER(_("hash_full_tree"));
+  SL_ENTER(_("sh_hash_compdata"));
 
   if (IsInit != 1) 
-    SL_RETURN(0, _("hash_full_tree"));
-
-  SH_MUTEX_LOCK_UNSAFE(mutex_hash);
+    SL_RETURN(0, _("sh_hash_compdata"));
+
   for (i = 0; i < TABSIZE; ++i)
     {
       for (p = tab[i]; p; p = p->next)
-	CLEAR_SH_FFLAG_ALLIGNORE(p->fflags);
-    }
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_hash);
-  SL_RETURN (0, _("hash_full_tree"));
+	p->allignore  = S_FALSE;
+    }
+  SL_RETURN (0, _("sh_hash_compdata"));
 } 
 
-#if !defined(SH_CUTEST)
-static 
-#endif
-int hash_remove_tree_test(char * s, char * fullpath, size_t len_s)
-{
-  size_t       len_p;
-  char      *  test;
-
-  len_p = strlen(fullpath);
-  
-  if (len_p >= len_s)
-    {
-      if (0 == strncmp(s, fullpath, len_s)) 
-	{ 
-	  if (len_p > len_s)
-	    {
-	      /* continue if not inside directory;
-	       * len_s > 1 because everything is inside '/' 
-	       */
-	      if ((len_s > 1) && (fullpath[len_s] != '/'))
-		return S_FALSE;
-
-	      test = sh_files_find_mostspecific_dir(fullpath);
-	      
-	      if (test && 0 != strcmp(test, s)) {
-		/* There is a more specific directory, continue */
-		return S_FALSE;
-	      }
-	      
-	      if (NULL == sh_files_findfile(fullpath)) {
-		/* SET_SH_FFLAG_ALLIGNORE(p->fflags); */
-		return S_TRUE;
-	      }
-	    }
-	  else /* len_p == len */
-	    {
-	      /* it is 's' itself, mark and continue 
-	       * unless there is a policy for the inode itself
-	       */
-	      if (NULL == sh_files_findfile(fullpath)) {
-		/* SET_SH_FFLAG_ALLIGNORE(p->fflags); */
-		return S_TRUE;
-	      }
-	      else {
-		return S_FALSE;
-	      }
-	    }
-
-	} /* if path is in tree */
-    } /* if path is possibly in tree */
-  return S_FALSE;
-}
-
 
 int hash_remove_tree (char * s) 
 {
-  sh_file_t *  p;
-  size_t       len_s;
-  unsigned int i;
+  sh_file_t * p;
+  int         len;
+  int         i;
 
   SL_ENTER(_("hash_remove_tree"));
 
-  if (!s || *s == '\0')
+  if (!s)
     SL_RETURN ((-1), _("hash_remove_tree"));
-
-  len_s = sl_strlen(s);
+  else
+    len = sl_strlen(s);
 
   if (IsInit != 1) 
     sh_hash_init();
 
-  SH_MUTEX_LOCK_UNSAFE(mutex_hash);
   for (i = 0; i < TABSIZE; ++i)
     {
       for (p = tab[i]; p; p = p->next)
 	{
-	  if (p->fullpath)
-	    {
-	      /* if (0 == strncmp(s, p->fullpath, len_s)) *//* old */
-	      if (S_TRUE == hash_remove_tree_test(s, p->fullpath, len_s)) {
-		SET_SH_FFLAG_ALLIGNORE(p->fflags);
-		MODI_SET(p->theFile.checkflags, MODI_ALLIGNORE);
-	      }
-	    } /* if path is not null */
-
-	}
-    }
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_hash);
+	  if (sl_strncmp(s, p->fullpath, len) == 0)
+	    { 
+	      p->allignore  = S_TRUE;
+	    }
+	}
+    }
   SL_RETURN ((0), _("hash_remove_tree"));
 } 
 
+#if TIME_WITH_SYS_TIME
+#include <sys/time.h>
+#include <time.h>
+#else
 #if HAVE_SYS_TIME_H
 #include <sys/time.h>
-#endif
+#else
 #include <time.h>
-
-static int ListFullDetail    = S_FALSE;
+#endif
+#endif
+
+static int ListFullDetail = S_FALSE;
 static int ListWithDelimiter = S_FALSE;
-static char * ListFile       = NULL;
-
-int set_list_file (const char * c)
-{
-  ListFile = sh_util_strdup(c);
-  return 0;
-}
-char * get_list_file()
-{
-  return ListFile;
-}
-
-int set_full_detail (const char * c)
-{
-  (void) c;
+
+int set_full_detail (char * c)
+{
   ListFullDetail = S_TRUE;
-  return 0;
+  /* warning: unused parameter `c' */
+  if (c)
+    return 0;
+  else
+    return 0;
 }
  
-int set_list_delimited (const char * c)
-{
-  (void) c;
+int set_list_delimited (char * c)
+{
   ListFullDetail = S_TRUE;
   ListWithDelimiter = S_TRUE;
-  return 0;
-}
-
-/* Always quote the string, except if it is empty. Quote quotes by
- * doubling them.
- */
-char * csv_escape(const char * str)
-{
-  const  char * p = str;
-  const  char * q;
-
-  size_t size       = 0;
-  size_t flag_quote = 0;
-
-  char * new;
-  char * pnew;
-
-  if (p)
-    {
-
-      while (*p) 
-	{
-	  if (*p == '"')
-	    ++flag_quote;
-	  
-	  ++size; ++p;
-	}
-
-      if (sl_ok_adds(size, flag_quote))
-	size += flag_quote;      /* double each quote */
-      else
-	return NULL;
-
-      if (sl_ok_adds(size, 3))
-	size += 3; /* two quotes and terminating null */
-      else
-	return NULL;
-      
-      new = SH_ALLOC(size);
-      
-      if (flag_quote != 0)
-	{
-	  new[0] = '"';
-	  pnew = &new[1];
-	  q    = str;
-	  while (*q)
-	    {
-	      *pnew = *q;
-	      if (*pnew == '"')
-		{
-		  ++pnew; *pnew = '"';
-		}
-	      ++pnew; ++q;
-	    }
-	  *pnew = '"'; ++pnew;
-	  *pnew = '\0';
-	}
-      else
-	{
-	  if (size > 3) 
-	    {
-	      new[0] = '"';
-	      sl_strlcpy (&new[1], str, size-1);
-	      new[size-2] = '"';
-	      new[size-1] = '\0';
-	    }
-	  else
-	    {
-	      new[0] = '\0';
-	    }
-	}
-
-      return new;
-    }
-  return NULL;
-}
-
-int isHexKey(char * s)
-{
-  int i;
-  
-  for (i = 0; i < KEY_LEN; ++i)
-    {
-      if (*s)
-	{
-	  if ((*s >= '0' && *s <= '9') ||
-	      (*s >= 'A' && *s <= 'F') ||
-	      (*s >= 'a' && *s <= 'f'))
-	    {
-	      ++s;
-	      continue;
-	    }
-	}
-      return S_FALSE;
-    }
-  return S_TRUE;
+  /* warning: unused parameter `c' */
+  if (c)
+    return 0;
+  else
+    return 0;
 }
  
-#include "sh_checksum.h"
-
-static char * KEYBUFtolower (char * s, char * result)
-{
-  char * r = result;
-  if (s)
-    {
-      for (; *s; ++s)
-	{ 
-	  *r = tolower((unsigned char) *s); ++r;
-	}
-      *r = '\0';
-    }
-  return result;
-}
-
 void sh_hash_list_db_entry_full_detail (sh_file_t * p)
 {
   char * tmp;
-  char * esc;
   char   str[81];
-  char   hexdigest[SHA256_DIGEST_STRING_LENGTH];
-  char   keybuffer[KEYBUF_SIZE];
 
   if (ListWithDelimiter == S_TRUE)
     {
-      printf(_("%7ld, %7ld, %10s, %5d, %12s, %5d, %3d, %-8s, %5d, %-8s, %5d, "),
-	     (unsigned long) p->theFile.ino, (unsigned long) p->theFile.dev,
+      printf(_("%7ld, %10s, %5d, %12s, %5d, %3d, %-8s, %5d, %-8s, %5d, "),
+	     (unsigned long) p->theFile.ino,
 	     p->theFile.c_mode, (int) p->theFile.mode,
 	     p->theFile.c_attributes, (int) p->theFile.attributes,
@@ -3047,6 +3139,6 @@
   else
     {
-      printf(_("%7ld %7ld %10s %5d %12s %5d %3d %-8s %5d %-8s %5d "),
-	     (unsigned long) p->theFile.ino, (unsigned long) p->theFile.dev,
+      printf(_("%7ld %10s %5d %12s %5d %3d %-8s %5d %-8s %5d "),
+	     (unsigned long) p->theFile.ino,
 	     p->theFile.c_mode, (int) p->theFile.mode,
 	     p->theFile.c_attributes, (int) p->theFile.attributes,
@@ -3057,7 +3149,7 @@
 
   if ('c' == p->theFile.c_mode[0] || 'b' == p->theFile.c_mode[0])
-    sl_snprintf(str, sizeof(str), "%"PRIu64, p->theFile.rdev);
-  else
-    sl_snprintf(str, sizeof(str), "%"PRIu64, p->theFile.size);
+    sl_snprintf(str, 80, "%"PRIi64, p->theFile.rdev);
+  else
+    sl_snprintf(str, 80, "%"PRIi64, p->theFile.size);
 
   printf( _(" %8s"), str);
@@ -3065,74 +3157,34 @@
     putchar(',');
 
-  printf( _(" %s"), sh_unix_gmttime (p->theFile.ctime, str, sizeof(str)));
+  printf( _(" %s"), sh_unix_gmttime (p->theFile.ctime));
   if (ListWithDelimiter == S_TRUE)
     putchar(',');
-  printf( _(" %s"), sh_unix_gmttime (p->theFile.mtime, str, sizeof(str)));
+  printf( _(" %s"), sh_unix_gmttime (p->theFile.mtime));
   if (ListWithDelimiter == S_TRUE)
     putchar(',');
-  printf( _(" %s"), sh_unix_gmttime (p->theFile.atime, str, sizeof(str)));
+  printf( _(" %s"), sh_unix_gmttime (p->theFile.atime));
   if (ListWithDelimiter == S_TRUE)
     putchar(',');
-
-  if (isHexKey(p->theFile.checksum))
-    printf( _(" %s"), KEYBUFtolower(p->theFile.checksum, keybuffer));
-  else
-    printf( _(" %s"), SHA256_Base2Hex(p->theFile.checksum, hexdigest));
+  printf( _(" %s"), p->theFile.checksum);
   if (ListWithDelimiter == S_TRUE)
     putchar(',');
 
   tmp = sh_util_safe_name(p->fullpath);
-  if (ListWithDelimiter != S_TRUE)
-    {
-      printf( _(" %s"), tmp);
-    }
-  else
-    {
-      esc = csv_escape(tmp);
-      printf( _(" %s,"), (esc != NULL) ? esc : _("(null)"));
-      if (esc)
-	SH_FREE(esc);
-    }
+  printf( _(" %s"), tmp);
   SH_FREE(tmp);
+  if (ListWithDelimiter == S_TRUE)
+    putchar(',');
 
   if ('l' == p->theFile.c_mode[0])
     {
       tmp = sh_util_safe_name(p->linkpath);
-      if (ListWithDelimiter != S_TRUE)
-	{
-	  printf(_(" -> %s"), tmp);
-	}
+      if (ListWithDelimiter == S_TRUE)
+	printf(_(" %s\n"), tmp);
       else
-	{
-	  esc = csv_escape(tmp);
-	  printf( _(" %s,"), (esc != NULL) ? esc : _("(null)"));
-	  if (esc)
-	    SH_FREE(esc);
-	}
+	printf(_(" -> %s\n"), tmp);
       SH_FREE(tmp);
     }
-
-  if (p->attr_string)
-    {
-      tmp = sh_util_safe_name(p->attr_string);
-      if (ListWithDelimiter != S_TRUE) 
-	{
-	  printf(_(" %s"), tmp);
-	}
-      else
-	{
-	  esc = csv_escape(tmp);
-	  printf( _(" %s"), (esc != NULL) ? esc : _("(null)"));
-	  if (esc)
-	    SH_FREE(esc);
-	}
-      SH_FREE(tmp);
-    }
-  else
-    {
-      if (ListWithDelimiter == S_TRUE)
-	printf("%s",_(" no_attr"));
-    }
-  putchar('\n');
+  else
+    printf("\n");
 
   return;
